package exnihilocreatio.client.renderers;

import com.google.common.collect.Lists;
import exnihilocreatio.blocks.BlockInfestingLeaves;
import exnihilocreatio.client.models.ModelVertex;
import exnihilocreatio.texturing.Color;
import exnihilocreatio.tiles.TileInfestingLeaves;
import exnihilocreatio.util.Util;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.BakedQuad;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.client.renderer.vertex.VertexFormatElement;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.biome.BiomeColorHelper;
import net.minecraftforge.client.model.animation.FastTESR;
import net.minecraftforge.client.model.pipeline.LightUtil;
import org.lwjgl.opengl.GL11;

import java.util.List;


public class RenderInfestingLeaves extends TileEntitySpecialRenderer<TileInfestingLeaves> {
    @Override
    public void func_192841_a(TileInfestingLeaves tile, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
        if (tile != null) {
            long seed = tile.func_145831_w().field_73012_v.nextLong();
            int color = tile.getColor();

            IBlockState leafBlock = tile.getLeafBlock();
            IBakedModel leafModel = Minecraft.func_71410_x().func_175602_ab().func_184389_a(leafBlock);

            if (leafModel == Minecraft.func_71410_x().func_175602_ab().func_175023_a().func_178126_b().func_174951_a())
                leafModel = Minecraft.func_71410_x().func_175602_ab().func_184389_a(Blocks.field_150362_t.func_176223_P());

            List<BakedQuad> leafQuads = Lists.newArrayList();

            for (EnumFacing side : EnumFacing.field_82609_l)
                if (leafBlock.func_185894_c(tile.func_145831_w(), tile.func_174877_v(), side))
                    leafQuads.addAll(leafModel.func_188616_a(leafBlock, side, seed));

            Tessellator tessellator = Tessellator.func_178181_a();
            BufferBuilder buffer = tessellator.func_178180_c();

            func_147499_a(TextureMap.field_110575_b);

            GlStateManager.func_179094_E();
            GlStateManager.func_179137_b(x, y, z);
            RenderHelper.func_74518_a();

            buffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176599_b);

            for (BakedQuad quad : leafQuads)
                LightUtil.renderQuadColor(buffer, quad, color);

            tessellator.func_78381_a();

            RenderHelper.func_74519_b();
            GlStateManager.func_179121_F();
        }
    }
}
