package exnihilocreatio.recipes.defaults;

import exnihilocreatio.blocks.BlockSieve;
import exnihilocreatio.items.ore.ItemOre;
import exnihilocreatio.registries.manager.ExNihiloRegistryManager;
import exnihilocreatio.registries.registries.OreRegistry;
import exnihilocreatio.registries.registries.SieveRegistry;
import exnihilocreatio.texturing.Color;
import lombok.Getter;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;

public class Mekanism implements IRecipeDefaults {
    @Getter
    public String MODID = "mekanism";

    public void registerSieve(SieveRegistry registry) {
        ItemOre osmium = ExNihiloRegistryManager.ORE_REGISTRY.getOreItem("osmium");
        if (osmium != null) {
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemStack(osmium, 1, 0), 0.05f, BlockSieve.MeshType.IRON.getID());
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemStack(osmium, 1, 0), 0.1f, BlockSieve.MeshType.DIAMOND.getID());
        }
    }

    public void registerOreChunks(OreRegistry registry) {
        // Osmium
        registry.register("osmium", new Color("BBDDFF"), null);
        ItemOre ore = ExNihiloRegistryManager.ORE_REGISTRY.getOreItem("osmium");
        registry.getSieveBlackList().add(ore); //Disables the default sieve recipes
    }
}
